commit b30d4608dae994cf57cab4824f3307de026fd373
Author: bellard <bellard@c046a42c-6fe2-441c-8c8c-71466251a162>
Date:   Tue Jul 6 01:50:49 2004 +0000

    24 bpp fixes
    
    
    git-svn-id: svn://svn.savannah.nongnu.org/qemu/trunk@984 c046a42c-6fe2-441c-8c8c-71466251a162

diff --git a/hw/cirrus_vga_rop2.h b/hw/cirrus_vga_rop2.h
index 540e308..5521870 100644
--- a/hw/cirrus_vga_rop2.h
+++ b/hw/cirrus_vga_rop2.h
@@ -67,6 +67,12 @@ glue(glue(glue(cirrus_patternfill_, ROP_NAME), _),DEPTH)
 #elif DEPTH == 16
             col = ((uint16_t *)(src1 + pattern_x))[0];
             pattern_x = (pattern_x + 2) & 15;
+#elif DEPTH == 24
+            {
+                const uint8_t *src2 = src1 + pattern_x * 3;
+                col = src2[0] | (src2[1] << 8) | (src2[2] << 16);
+                pattern_x = (pattern_x + 1) & 7;
+            }
 #else
             col = ((uint32_t *)(src1 + pattern_x))[0];
             pattern_x = (pattern_x + 4) & 31;
@@ -89,21 +95,28 @@ glue(glue(glue(cirrus_colorexpand_transp_, ROP_NAME), _),DEPTH)
 {
     uint8_t *d;
     int x, y;
-    unsigned bits;
+    unsigned bits, bits_xor;
     unsigned int col;
     unsigned bitmask;
     unsigned index;
     int srcskipleft = 0;
 
-    col = s->cirrus_blt_fgcol;
+    if (s->cirrus_blt_modeext & CIRRUS_BLTMODEEXT_COLOREXPINV) {
+        bits_xor = 0xff;
+        col = s->cirrus_blt_bgcol;
+    } else {
+        bits_xor = 0x00;
+        col = s->cirrus_blt_fgcol;
+    }
+
     for(y = 0; y < bltheight; y++) {
         bitmask = 0x80 >> srcskipleft;
-        bits = *src++;
+        bits = *src++ ^ bits_xor;
         d = dst;
         for (x = 0; x < bltwidth; x += (DEPTH / 8)) {
             if ((bitmask & 0xff) == 0) {
                 bitmask = 0x80;
-                bits = *src++;
+                bits = *src++ ^ bits_xor;
             }
             index = (bits & bitmask);
             if (index) {
@@ -116,23 +129,23 @@ glue(glue(glue(cirrus_colorexpand_transp_, ROP_NAME), _),DEPTH)
     }
 }
 
-/* NOTE: srcpitch is ignored */
 static void
-glue(glue(glue(cirrus_colorexpand_transp_inv_, ROP_NAME), _),DEPTH)
+glue(glue(glue(cirrus_colorexpand_, ROP_NAME), _),DEPTH)
      (CirrusVGAState * s, uint8_t * dst,
       const uint8_t * src, 
       int dstpitch, int srcpitch, 
       int bltwidth, int bltheight)
 {
+    uint32_t colors[2];
     uint8_t *d;
     int x, y;
     unsigned bits;
     unsigned int col;
     unsigned bitmask;
-    unsigned index;
     int srcskipleft = 0;
 
-    col = s->cirrus_blt_bgcol;
+    colors[0] = s->cirrus_blt_bgcol;
+    colors[1] = s->cirrus_blt_fgcol;
     for(y = 0; y < bltheight; y++) {
         bitmask = 0x80 >> srcskipleft;
         bits = *src++;
@@ -142,19 +155,54 @@ glue(glue(glue(cirrus_colorexpand_transp_inv_, ROP_NAME), _),DEPTH)
                 bitmask = 0x80;
                 bits = *src++;
             }
-            index = (bits & bitmask);
-            if (!index) {
+            col = colors[!!(bits & bitmask)];
+            PUTPIXEL();
+            d += (DEPTH / 8);
+            bitmask >>= 1;
+        }
+        dst += dstpitch;
+    }
+}
+
+static void
+glue(glue(glue(cirrus_colorexpand_pattern_transp_, ROP_NAME), _),DEPTH)
+     (CirrusVGAState * s, uint8_t * dst,
+      const uint8_t * src, 
+      int dstpitch, int srcpitch, 
+      int bltwidth, int bltheight)
+{
+    uint8_t *d;
+    int x, y, bitpos, pattern_y;
+    unsigned int bits, bits_xor;
+    unsigned int col;
+
+    if (s->cirrus_blt_modeext & CIRRUS_BLTMODEEXT_COLOREXPINV) {
+        bits_xor = 0xff;
+        col = s->cirrus_blt_bgcol;
+    } else {
+        bits_xor = 0x00;
+        col = s->cirrus_blt_fgcol;
+    }
+    pattern_y = s->cirrus_blt_srcaddr & 7;
+
+    for(y = 0; y < bltheight; y++) {
+        bits = src[pattern_y] ^ bits_xor;
+        bitpos = 7;
+        d = dst;
+        for (x = 0; x < bltwidth; x += (DEPTH / 8)) {
+            if ((bits >> bitpos) & 1) {
                 PUTPIXEL();
             }
             d += (DEPTH / 8);
-            bitmask >>= 1;
+            bitpos = (bitpos - 1) & 7;
         }
+        pattern_y = (pattern_y + 1) & 7;
         dst += dstpitch;
     }
 }
 
 static void
-glue(glue(glue(cirrus_colorexpand_, ROP_NAME), _),DEPTH)
+glue(glue(glue(cirrus_colorexpand_pattern_, ROP_NAME), _),DEPTH)
      (CirrusVGAState * s, uint8_t * dst,
       const uint8_t * src, 
       int dstpitch, int srcpitch, 
@@ -162,28 +210,25 @@ glue(glue(glue(cirrus_colorexpand_, ROP_NAME), _),DEPTH)
 {
     uint32_t colors[2];
     uint8_t *d;
-    int x, y;
-    unsigned bits;
+    int x, y, bitpos, pattern_y;
+    unsigned int bits;
     unsigned int col;
-    unsigned bitmask;
-    int srcskipleft = 0;
 
     colors[0] = s->cirrus_blt_bgcol;
     colors[1] = s->cirrus_blt_fgcol;
+    pattern_y = s->cirrus_blt_srcaddr & 7;
+
     for(y = 0; y < bltheight; y++) {
-        bitmask = 0x80 >> srcskipleft;
-        bits = *src++;
+        bits = src[pattern_y];
+        bitpos = 7;
         d = dst;
         for (x = 0; x < bltwidth; x += (DEPTH / 8)) {
-            if ((bitmask & 0xff) == 0) {
-                bitmask = 0x80;
-                bits = *src++;
-            }
-            col = colors[!!(bits & bitmask)];
+            col = colors[(bits >> bitpos) & 1];
             PUTPIXEL();
             d += (DEPTH / 8);
-            bitmask >>= 1;
+            bitpos = (bitpos - 1) & 7;
         }
+        pattern_y = (pattern_y + 1) & 7;
         dst += dstpitch;
     }
 }